vshost-util-vserver

Build script and sources for util-vserver.
git clone https://ccx.te2000.cz/git/vshost-util-vserver
Log | Files | Refs

vmount (2805B)


      1 #!/bin/bash
      2 # $Id$
      3 
      4 # Copyright (C) 2007 Daniel Hokka Zakrisson
      5 #  
      6 # This program is free software; you can redistribute it and/or modify
      7 # it under the terms of the GNU General Public License as published by
      8 # the Free Software Foundation; version 2 of the License.
      9 #  
     10 # This program is distributed in the hope that it will be useful,
     11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     13 # GNU General Public License for more details.
     14 #  
     15 # You should have received a copy of the GNU General Public License
     16 # along with this program; if not, write to the Free Software
     17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
     18 
     19 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
     20 test -e "$UTIL_VSERVER_VARS" || {
     21     echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
     22     exit 1
     23 }
     24 . "$UTIL_VSERVER_VARS"
     25 . "$_LIB_FUNCTIONS"
     26 
     27 
     28 function showHelp()
     29 {
     30     echo \
     31 $"Usage: $0 <vserver-name> -- [-o options] [--bind|--rbind]
     32          [-t <type>] [-a] [-n] [--move]
     33          [<source> [<destination>]]
     34 
     35 <source>       ...  what to mount, this is relative to the host's root
     36 <destination>  ...  where to mount it, this is relative to the guest's root
     37 
     38 Report bugs to <$PACKAGE_BUGREPORT>."
     39     exit 0
     40 }
     41 
     42 function showVersion()
     43 {
     44     echo \
     45 $"vmount $PACKAGE_VERSION -- mount for guests
     46 This program is part of $PACKAGE_STRING
     47 
     48 Copyright (C) 2007 Daniel Hokka Zakrisson
     49 This program is free software; you may redistribute it under the terms of
     50 the GNU General Public License.  This program has absolutely no warranty."
     51     exit 0
     52 }
     53 
     54 
     55 declare -a guests
     56 while test $# -gt 0; do
     57     case "$1" in
     58 	(--)	shift; break;;
     59         (-*)    break;;
     60 	(*)
     61 	    _setVserverDir "$1"
     62 	    guests=( "${guests[@]}" "$VSERVER_DIR" )
     63 	    ;;
     64     esac
     65     shift
     66 done
     67 
     68 tmp=$(getopt -o +o:t:an --long help,version,debug,bind,rbind,move -n "$0" -- "$@") || exit 1
     69 eval set -- "$tmp"
     70 
     71 declare -a options
     72 fstype=""
     73 while true; do
     74     case "$1" in
     75 	(--help)	showHelp $0 ;;
     76 	(--version)	showVersion ;;
     77 	(--debug)	set -x;;
     78 	(--bind|--rbind|--move|-n|-a)
     79 			options=( "${options[@]}" "$1" )
     80 			;;
     81 	(-t|-o)		options=( "${options[@]}" "$1" "$2" )
     82 			test "$1" != "-t" || fstype="$1"
     83 			shift
     84 			;;
     85 	(--)		shift; break;;
     86 	(*)		echo $"vmount: internal error; arg=='$1'" >&2; exit 1;;
     87     esac
     88     shift
     89 done
     90 
     91 case "x$1" in
     92     (x/*|x)	;;
     93     (*)		test "$fstype" = "nfs" || panic $"vmount: the source must be an absolute path";;
     94 esac
     95 
     96 rc=0
     97 for guest in "${guests[@]}"; do
     98     pushd "$guest/vdir" &> /dev/null
     99     callInNamespace "$guest" \
    100 	$_SECURE_MOUNT --chroot --fstab "$guest/fstab" "${options[@]}" "$@"
    101     test "$?" -eq 0 || rc=$?
    102     popd &> /dev/null
    103 done
    104 
    105 exit $rc